#include "applet.h"

#include "mta_interface.h"

#include <assert.h>

#include <gnome.h>
#include <applet-widget.h>

#include "mailq_0.xpm"
#include "mailq_1.xpm"

static GtkWidget* applet;
static GtkWidget* pixmap;
static int update_timeout_id=FALSE;

#define APP "mailq_applet"
#define VERSION "0.2"

static gint update(void)
{
  int queue_size;
  static int last_queue_size=-1;
  queue_size=get_mail_queue_length();
  if(queue_size!=last_queue_size){
    last_queue_size=queue_size;
    gnome_pixmap_load_xpm_d(GNOME_PIXMAP(pixmap),
			    queue_size?mailq_1_xpm:mailq_0_xpm);
  }
  return TRUE;
}

static void start_callback_update(void)
{
  gint delay;
  delay=1000; // ms
  update_timeout_id=gtk_timeout_add(delay,(GtkFunction)update,NULL);
}

int main(int argc, char* argv[])
{
  init_mta_interface();
  applet_widget_init(APP,VERSION,argc,argv,NULL,0,NULL);
  applet=applet_widget_new(APP);
  assert(applet);
  pixmap=gnome_pixmap_new_from_xpm_d(mailq_0_xpm);
  assert(pixmap);
  applet_widget_add(APPLET_WIDGET(applet),pixmap);
  gtk_widget_show(pixmap);
  gtk_widget_show(applet);
  start_callback_update();
  applet_widget_gtk_main();
  return 0;
}

  
